import glob, os
from PIL import Image
import argparse
from pathlib import Path
import tqdm


w, h = 200,120

PATTERN = 'keyframes'
REPLACE = 'thumbs'


def resize_img(src, dest):
    paths = Path(src).rglob('*.*')
    paths_list = list(paths)

    for path in tqdm.tqdm(paths_list):
        outfile = str(path).replace(PATTERN, REPLACE)
        folders = os.path.dirname(outfile)

        #print(outfile)

        if not os.path.isdir(folders):
            #print(folders)
            os.makedirs(folders)

        try:
            im = Image.open(path)
            if im.mode in ("RGBA", "P"):
                im = im.convert("RGB")
            im.thumbnail((w, h), Image.ANTIALIAS)
            im.save(outfile, "JPEG")
        except IOError:
            print("cannot create thumbnail for '%s'" % path)
            pass


if __name__ == '__main__':
   # parser = argparse.ArgumentParser(description='Image resizing')
   # parser.add_argument('src', type=str, help='images source folder path')
   # parser.add_argument('dest', type=str, help='images dest folder path')

    #args = parser.parse_args()
    #resize_img(args.src, args.dest)
    resize_img('/media/Data/data/rai/img/keyframes', '/media/Data/data/rai/img/keyframes')
    #resize_img('/media/Data/data/test/gem/img/originals/ImmaginiComparazioni', '/media/Data/data/test/gem/img/ImmaginiComparazioni_resized')
